searchData={"content_type":"text/markdown","items":[{"doc":"A function to customize json.","ref":"dsl-ashjason-extension.html#jason-customize","title":"AshJason.Extension.jason.customize","type":"DSL"},{"doc":"A map to merge into json.","ref":"dsl-ashjason-extension.html#jason-merge","title":"AshJason.Extension.jason.merge","type":"DSL"},{"doc":"Keys to omit from a record (despite `fields`/`pick`).","ref":"dsl-ashjason-extension.html#jason-omit","title":"AshJason.Extension.jason.omit","type":"DSL"},{"doc":"Keys to pick from a record (in addition to `fields`).","ref":"dsl-ashjason-extension.html#jason-pick","title":"AshJason.Extension.jason.pick","type":"DSL"},{"doc":"Fields to pick from a record and include in json (default: all public non-sensitive fields).","ref":"dsl-ashjason-extension.html#jason-fields","title":"AshJason.Extension.jason.fields","type":"DSL"},{"doc":"Configuration for Jason encoder implementation","ref":"dsl-ashjason-extension.html#jason","title":"AshJason.Extension.jason","type":"DSL"},{"doc":"","ref":"AshJason.Extension.html","title":"AshJason.Extension","type":"module"},{"doc":"","ref":"AshJason.Transformer.html","title":"AshJason.Transformer","type":"module"},{"doc":"","ref":"AshJason.Transformer.html#after?/1","title":"AshJason.Transformer.after?/1","type":"function"},{"doc":"","ref":"AshJason.Transformer.html#after_compile?/0","title":"AshJason.Transformer.after_compile?/0","type":"function"},{"doc":"","ref":"AshJason.Transformer.html#before?/1","title":"AshJason.Transformer.before?/1","type":"function"},{"doc":"","ref":"AshJason.Transformer.html#transform/1","title":"AshJason.Transformer.transform/1","type":"function"},{"doc":"# AshJason\n\n[![Module Version](https://img.shields.io/hexpm/v/ash_jason)](https://hex.pm/packages/ash_jason)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen)](https://hexdocs.pm/ash_jason/)\n[![License](https://img.shields.io/hexpm/l/ash_jason)](https://github.com/vonagam/ash_jason/blob/master/LICENSE.md)\n\nAsh resource extension for implementing Jason.Encoder protocol.","ref":"readme.html","title":"Guide","type":"extras"},{"doc":"Add to the deps, get deps (`mix deps.get`), compile them (`mix deps.compile`).\n\n```elixir\ndef deps do\n  [\n    {:ash_jason, \"~> 0.2\"},\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Guide","type":"extras"},{"doc":"Add `AshJason.Extension` to `extensions` list in `use Ash.Resource`:\n\n```elixir\ndefmodule Example.Resource do\n  use Ash.Resource,\n    extensions: [Ash.ULID.Extension]\nend\n```\n\nBy default encodes all non-private fields (attributes/relationships/aggregates/calculations) with loaded non-nil values.\n\n#","ref":"readme.html#usage","title":"Usage - Guide","type":"extras"},{"doc":"For configuration there is an optional `jason` dsl section:\n\n```elixir\ndefmodule Example.Resource do\n  use Ash.Resource,\n    extensions: [Ash.ULID.Extension]\n\n  jason do\n    # options\n  end\nend\n```\n\n##","ref":"readme.html#configuration","title":"Configuration - Guide","type":"extras"},{"doc":"Fields to pick from a record and include in json.\nFeilds with values of `nil`/`Ash.NotLoaded`/`Ash.NotSelected` are omitted.\nBy default includes all public non-sensitive fields (attributes/relationships/aggregates/calculations).\nSpecifying `fields` overwrites that default, `pick`/`omit` can be used instead to simply modify it.\n\n```elixir\njason do\n  fields [:only_some_field]\nend\n```\n\n##","ref":"readme.html#fields","title":"fields - Guide","type":"extras"},{"doc":"Keys to pick from a record in addition to `fields`.\nCan be used to whitelist some private/sensitive attributes or custom non-field properties.\n\n```elixir\njason do\n  pick [:additional_key]\nend\n```\n\n##","ref":"readme.html#pick","title":"pick - Guide","type":"extras"},{"doc":"Keys to omit from `fields`/`pick`.\nCan be used to blacklist some public attributes that get included by default.\n\n```elixir\njason do\n  omit [:privatish_key]\nend\n```\n\n##","ref":"readme.html#omit","title":"omit - Guide","type":"extras"},{"doc":"A map to merge into json.\n\n```elixir\njason do\n  merge %{merged_key: \"merged_value\"}\nend\n```\n\n##","ref":"readme.html#merge","title":"merge - Guide","type":"extras"},{"doc":"A function to customize json.\nReceives a current resulted json map and a source resource record.\nReturns a modified json map.\n\n```elixir\njason do\n  customize fn result, _record ->\n    result |> Map.put(:custom_key, \"custom_value\")\n  end\nend\n```","ref":"readme.html#customize","title":"customize - Guide","type":"extras"},{"doc":"[`Jason` docs](https://hexdocs.pm/jason).","ref":"readme.html#links","title":"Links - Guide","type":"extras"},{"doc":"MIT License\n\nCopyright (c) 2023 Dmitry Maganov\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshJason.Extension","ref":"dsl-ashjason-extension.html","title":"DSL: AshJason.Extension","type":"extras"},{"doc":"Configuration for Jason encoder implementation\n\n\n\n\n\n\n#","ref":"dsl-ashjason-extension.html#jason","title":"jason - DSL: AshJason.Extension","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`fields`](#jason-fields){: #jason-fields } | `list(atom)` |  | Fields to pick from a record and include in json (default: all public non-sensitive fields). |\n| [`pick`](#jason-pick){: #jason-pick } | `list(atom)` |  | Keys to pick from a record (in addition to `fields`). |\n| [`omit`](#jason-omit){: #jason-omit } | `list(atom)` |  | Keys to omit from a record (despite `fields`/`pick`). |\n| [`merge`](#jason-merge){: #jason-merge } | `map` |  | A map to merge into json. |\n| [`customize`](#jason-customize){: #jason-customize } | `(map, map -> map)` |  | A function to customize json. |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-ashjason-extension.html#options","title":"Options - DSL: AshJason.Extension","type":"extras"}]}